from pathlib import Path

import pytest
from pyscaffold import cli
from pyscaffold.file_system import chdir

from pyscaffoldext.pipenv.extension import Pipenv

from .helpers import run_common_tasks

EXT_FLAGS = [Pipenv().flag]

# If you need to check logs with caplog, have a look on
# pyscaffoldext-custom-extension's tests/conftest.py file and the
# `isolated_logger` fixture.


@pytest.fixture(params=["project", "my_project"], scope="function")
def project(request):
    yield request.param


@pytest.fixture(params=["my_package", "pkg"], scope="function")
def package(request):
    yield request.param


@pytest.fixture(params=["ns", "my.ns"], scope="function")
def namespace(request):
    yield request.param


def test_add_custom_extension(tmpfolder, project, package):
    args = [project, "--no-config", "-p", package, *EXT_FLAGS]
    # --no-config: avoid extra config from dev's machine interference
    cli.main(args)
    assert Path(f"{project}/Pipfile").exists()


def test_add_custom_extension_and_pretend(tmpfolder, project, package):
    args = [project, "--no-config", "--pretend", "-p", package, *EXT_FLAGS]
    # --no-config: avoid extra config from dev's machine interference
    cli.main(args)
    assert not Path("my_project").exists()


def test_add_custom_extension_with_namespace(tmpfolder, project, package, namespace):
    args = [
        project,
        "--no-config",  # avoid extra config from dev's machine interference
        "--package",
        package,
        "--namespace",
        namespace,
        *EXT_FLAGS,
    ]
    cli.main(args)

    assert Path(f"{project}/src/{namespace.replace('.','/')}/{package}/__init__.py")
    assert Path(f"{project}/Pipfile").exists()


# To use marks make sure to uncomment them in setup.cfg
# @pytest.mark.slow
def test_generated_extension(tmpfolder):
    args = [
        "my_project",
        "--no-config",  # avoid extra config from dev's machine interference
        "--venv",  # generate a venv so we can install the resulting project
        # "--pre-commit",  # ensure generated files respect repository conventions
        "--namespace",  # it is very easy to forget users might want to use namespaces
        "my.ns",  # ... so we automatically test the worst case scenario
        *EXT_FLAGS,
    ]
    cli.main(args)

    with chdir("my_project"):
        # Testing a project generated by the custom extension
        run_common_tasks(tests=True, docs=True, pre_commit=False, install=True)
